﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcNoe.DAL;

namespace MvcNoe.Controllers
{ 
    public class ValorRecomanatController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /ValorRecomanat/

        public ViewResult Index()
        {
            try
            {
                //mostrem dades de Temes i les seves preguntes. stored proc. fitrem per a un tema escollit
                return View(db.SP_IndexPregunta_EXTEND().ToList());
            }
            catch (Exception e)
            {
                //passem el missatge de error a la vista
                ViewBag.error = e.Message;
                //adrecem la vista de errors
                return View("Error");
            }
        }

        //
        // GET: /ValorRecomanat/ShowInfo/5
        //Mostrem les dades de les preguntes,les seves possibles respostes i el seu valor recomanat
        public ViewResult ShowInfo(string id)
        {
            try
            {
                //només dades actives
                //fem servir una crida a un stored procedure
                //return View(db.SP_Valors_recomanats_possibles_respostesxTemaxPregunta().ToList());

                //filtrar per tema

                String[] a = id.Split('_');
                String idTema = a[0];
                String idPregunta = a[1];
                
                
                //return View(db.SP_Valors_recomanats_possibles_respostes_EXTEND().ToList());
                //return View("ShowInfo", db.SP_Valors_recomanats_possibles_respostes_EXTEND().Where(t => t.id_tema == idTema.Trim()).ToList());
                //filtrem les dades fent servir un st. proc amb paràmetres. filtrem pel tema
                return View("ShowInfo", db.SP_Valors_recomanats_possibles_respostes_EXTEND_x_Tema(idTema).ToList());
            }
            catch (Exception e)
            {
                //passem el missatge de error a la vista
                ViewBag.error = e.Message;
                //adrecem la vista de errors
                return View("Error");
            }
        }


        //Action per a cridar a la vista de error
        // POST: /ForumMissatge/Error

        public ViewResult Error()
        {
            return View();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }


    }
}