﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;


namespace MvcSonin.Controllers
{ 
    public class CentreController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /Centre/

        public ViewResult Index()
        {
            return View(db.TBL_Centres.ToList());
        }

        //
        // GET: /Centre/Details/5
        /// <summary>
        /// 
        /// </summary>
        /// <param name="id">El codi de centre i la classe de centre a la mateixa cadena separats per _</param>
        /// <returns></returns>
        public ViewResult Details(string id)
        {

            //tractem la cadena id que rebem

            string idSap = "";
            string idUp = "";
            string idCentre = "";
            string ClasseCentre = "";

            string[] a = id.Split('_');

            idSap = a[0];
            idUp = a[1];
            idCentre = a[2];
            ClasseCentre = a[3];


            TBL_Centres tbl_centres = db.TBL_Centres.Single(t => t.codi_sap == idSap && t.codi_ics == idUp && t.id_centre == idCentre && t.classe_centre == ClasseCentre);
            return View(tbl_centres);
        }

        //
        // GET: /Centre/Create

        public ActionResult Create()
        {
            //passem els valors de les UP per a la combo
            ViewBag.codi_ics = new SelectList(db.TBL_UP, "codi_ics", "desc_up");
            return View();
        } 

        //
        // POST: /Centre/Create

        [HttpPost]
        public ActionResult Create(TBL_Centres tbl_centres)
        {
            if (ModelState.IsValid)
            {
                //obtenim el id sap de la UP i el passem al tbl_
                tbl_centres.codi_sap = db.SP_GetIDSapFromUP(tbl_centres.codi_ics).ElementAt(0).id_sap;
                db.TBL_Centres.AddObject(tbl_centres);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }
            //afegim per a que surti el valor escollit als desplegables
            ViewBag.codi_ics = new SelectList(db.TBL_UP, "codi_ics", "desc_up", tbl_centres.codi_ics);
            return View(tbl_centres);
        }
        
        //
        // GET: /Centre/Edit/5
 
        public ActionResult Edit(string id)
        {
            //tractem la cadena id que rebem

            string idSap = "";
            string idUp = "";
            string idCentre = "";
            string ClasseCentre = "";

            string[] a = id.Split('_');

            idSap = a[0];
            idUp = a[1];
            idCentre = a[2];
            ClasseCentre = a[3];


            TBL_Centres tbl_centres = db.TBL_Centres.Single(t => t.codi_sap == idSap && t.codi_ics == idUp && t.id_centre == idCentre && t.classe_centre == ClasseCentre);
            return View(tbl_centres);
        }

        //
        // POST: /Centre/Edit/5

        [HttpPost]
        public ActionResult Edit(TBL_Centres tbl_centres)
        {
            if (ModelState.IsValid)
            {
                db.TBL_Centres.Attach(tbl_centres);
                db.ObjectStateManager.ChangeObjectState(tbl_centres, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(tbl_centres);
        }

        //
        // GET: /Centre/Delete/5
 
        public ActionResult Delete(string id)
        {
            //tractem la cadena id que rebem

            string idSap = "";
            string idUp = "";
            string idCentre = "";
            string ClasseCentre = "";

            string[] a = id.Split('_');

            idSap = a[0];
            idUp = a[1];
            idCentre = a[2];
            ClasseCentre = a[3];


            TBL_Centres tbl_centres = db.TBL_Centres.Single(t => t.codi_sap == idSap && t.codi_ics == idUp && t.id_centre == idCentre && t.classe_centre == ClasseCentre);
            return View(tbl_centres);
        }

        //
        // POST: /Centre/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {
            //canviem el codi generat pel framework ja que no esborrem sinò que editem els camps data de baixa 

            //tractem la cadena id que rebem

            string idSap = "";
            string idUp = "";
            string idCentre = "";
            string ClasseCentre = "";

            string[] a = id.Split('_');

            idSap = a[0];
            idUp = a[1];
            idCentre = a[2];
            ClasseCentre = a[3];

            TBL_Centres tbl_centres = db.TBL_Centres.Single(t => t.codi_sap == idSap && t.codi_ics == idUp && t.id_centre == idCentre && t.classe_centre == ClasseCentre);

            //editem la data de alta
            tbl_centres.data_baixa = System.DateTime.Now;
            //db.TBL_Temes.Attach(tbl_forums);
            db.ObjectStateManager.ChangeObjectState(tbl_centres, EntityState.Modified);
            db.SaveChanges();
            return RedirectToAction("Index");
   
        }

        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var centres = db.TBL_Centres.ToList();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from centrs in centres

                              select new
                              {
                                  Id_sap = centrs.codi_sap,
                                  Codi_up = centrs.codi_ics,
                                  Codi_centre = centrs.id_centre,
                                  Classe_centre = centrs.classe_centre,
                                  Nom_centre = centrs.desc_centre,
                                  Data_alta = centrs.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}