﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace MvcSonin.Controllers
{ 
    public class ForumController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /Forum/

        public ViewResult Index()
        {
            //return View(db.TBL_Forums.ToList());
            //fem servir la crida una fució que crida a un stored proc.
            //return View(db.SP_IndexForum());
            return View(db.SP_IndexForum_EXTEND());
        }

        //
        // GET: /Forum/Details/5

        public ViewResult Details(string id)
        {
            try
            {
                //tractem la cadena id que rebem.
                int posSeparador = id.IndexOf("_");
                int longParam = id.Length;
                int diferencia = 0;
                diferencia = longParam - posSeparador;

                string idForum = id.Substring(0, posSeparador);
                string idTema = id.Substring((posSeparador + 1), (diferencia - 1));
                //fent servir LINQ
                //TBL_Forums tbl_forums = db.TBL_Forums.Single(t => t.id_forum == idForum && t.id_tema==idTema);
                //return View(tbl_forums);

                //fem servir una crida una funció que crida a un stored proced.
                //com que ens tornen un conjunt de resutats i només volem un (i més a més els tipus no coincidexien) hem fet el "apaño" de fer servir ElementAt(0).
                //Només hi ha un sol element. Millorar el procés a posteriori
                TBL_Forums tbl_forums = (TBL_Forums)db.SP_DetailsForum(idForum, idTema).ElementAt(0);
                return View(tbl_forums);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }

        }

        //
        // GET: /Forum/Create

        public ActionResult Create()
        {

            ViewBag.id_tema = new SelectList(db.SP_IndexTema(), "id_tema", "desc_tema");

            //afegim per a que surti el valor escollit als desplegables
            //VERY IMPORTANT
            //el nom id_usuari_alta del ViewBag ha de ser igual que el nom del camp de la taula. Sinò
            //quan es genera el desplegable a la vista el nom per a després desar les dades ha de ésser
            //el mateix.
            //ViewBag.id_usuari_alta = new SelectList(db.TBL_Usuaris, "id_usuari", "nom_usuari");
           
            return View();
        } 

        //
        // POST: /Forum/Create

        [HttpPost]
        public ActionResult Create(TBL_Forums tbl_forums)
        {
            try
            {
                //insertem els valors de manera automàtica
                tbl_forums.id_usuari_alta = Session["usuari"].ToString();
                tbl_forums.id_forum = "Forum" + System.DateTime.Now.ToString().Replace("/", "").Replace(":", "").Replace(" ", "");

                if (ModelState.IsValid)
                {
                    db.TBL_Forums.AddObject(tbl_forums);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                //afegim per a que surti el valor escollit als desplegables
                ViewBag.id_tema = new SelectList(db.SP_IndexTema(), "id_tema", "desc_tema", tbl_forums.id_tema);
                //afegim per a que surti el valor escollit als desplegables
                //VERY IMPORTANT
                //el nom id_usuari_alta del ViewBag ha de ser igual que el nom del camp de la taula. Sinò
                //quan es genera el desplegable a la vista el nom per a després desar les dades ha de ésser
                //el mateix.
                //ViewBag.id_usuari_alta = new SelectList(db.TBL_Usuaris, "id_usuari", tbl_forums.id_usuari_alta);

                return View(tbl_forums);
            }
            catch (Exception ex)
            {
                ViewBag.error = ex.Message;
                return View(tbl_forums);
            }
        }
        
        //
        // GET: /Forum/Edit/5
 
        public ActionResult Edit(string id)
        {
            try
            {
                //tractem la cadena id que rebem.
                int posSeparador = id.IndexOf("_");
                int longParam = id.Length;
                int diferencia = 0;
                diferencia = longParam - posSeparador;

                string idForum = id.Substring(0, posSeparador);
                string idTema = id.Substring((posSeparador + 1), (diferencia - 1));

                TBL_Forums tbl_forums = db.TBL_Forums.Single(t => t.id_forum == idForum && t.id_tema == idTema);

                return View(tbl_forums);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // POST: /Forum/Edit/5

        [HttpPost]
        public ActionResult Edit(TBL_Forums tbl_forums)
        {
            try
            {

                if (ModelState.IsValid)
                {
                    db.TBL_Forums.Attach(tbl_forums);
                    db.ObjectStateManager.ChangeObjectState(tbl_forums, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                //afegim per a que surti el valor escollit als desplegables
                ViewBag.idTema = new SelectList(db.TBL_Temes, "id_tema", "desc_tema", tbl_forums.id_tema);
                return View(tbl_forums);

            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View(tbl_forums);
            }

        }

        //
        // GET: /Forum/Delete/5
 
        public ActionResult Delete(string id)
        {
            try
            {
                //tractem la cadena id que rebem.
                int posSeparador = id.IndexOf("_");
                int longParam = id.Length;
                int diferencia = 0;
                diferencia = longParam - posSeparador;

                string idForum = id.Substring(0, posSeparador);
                string idTema = id.Substring((posSeparador + 1), (diferencia - 1));
                //fent servir LINQ
                //TBL_Forums tbl_forums = db.TBL_Forums.Single(t => t.id_forum == idForum && t.id_tema==idTema);
                //return View(tbl_forums);

                //fem servir una crida una funció que crida a un stored proced.
                //com que ens tornen un conjunt de resutats i només volem un (i més a més els tipus no coincidexien) hem fet el "apaño" de fer servir ElementAt(0).
                //Només hi ha un sol element. Millorar el procés a posteriori
                TBL_Forums tbl_forums = (TBL_Forums)db.SP_DetailsForum(idForum, idTema).ElementAt(0);

                return View(tbl_forums);

            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // POST: /Forum/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {
            try
            {
                //canviem el codi ja que no esborrem sinò que editem els camps data de baixa 

                //i usuari de baixa 
                //tractem la cadena id que rebem.
                int posSeparador = id.IndexOf("_");
                int longParam = id.Length;
                int diferencia = 0;
                diferencia = longParam - posSeparador;

                string idForum = id.Substring(0, posSeparador);
                string idTema = id.Substring((posSeparador + 1), (diferencia - 1));


                //fem servir una crida una funció que crida a un stored proced.
                //com que ens tornen un conjunt de resutats i només volem un (i més a més els tipus no coincidexien) hem fet el "apaño" de fer servir ElementAt(0).
                //Només hi ha un sol element. Millorar el procés a posteriori
                TBL_Forums tbl_forums = (TBL_Forums)db.SP_DetailsForum(idForum, idTema).ElementAt(0);
                tbl_forums.id_usuari_baixa = Session["usuari"].ToString();
                tbl_forums.data_baixa = System.DateTime.Now;
                //db.TBL_Temes.Attach(tbl_forums);
                db.ObjectStateManager.ChangeObjectState(tbl_forums, EntityState.Modified);
                db.SaveChanges();

                //donem de baixa els objectes lligats amb el fòrum
                UpdateFK(tbl_forums.id_forum, Session["usuari"].ToString());

                return RedirectToAction("Index");

            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }


        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var forumes = db.SP_IndexForum_EXTEND();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from forums in forumes

                              select new
                              {
                                  Tema = forums.desc_tema,
                                  Forum = forums.desc_forum,
                                  Id_usuari_alta = forums.id_usuari_alta,
                                  Data_alta = forums.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }

        /// <summary>
        /// Actualitzem les dates de baixa i el usuari de baixa
        /// dels objectes relacionats amb el fòrum
        /// </summary>
        /// <param name="idTema">id del fòrum</param>
        /// <param name="idUsuariBaixa">id del  usuari de baixa</param>
        private void UpdateFK(String idForum, String idUsuariBaixa)
        {

            System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
            System.Data.SqlClient.SqlConnection cn = new System.Data.SqlClient.SqlConnection();

            //la cadena de connexió
            cn.ConnectionString = "Server = (local); Database = sonin; User ID = sonin; Password = sonin; Trusted_Connection = False";

            // si la connexió està tancada la obrim.
            if (cn.State == ConnectionState.Closed)
            {
                cn.Open();
            }

            cmd.Connection = cn;


            //els forums discussions
            cmd.CommandText = "UPDATE TBL_Forums_discussions SET data_baixa = '" + System.DateTime.Now.ToString() + "', id_usuari_baixa ='" + idUsuariBaixa + "'   WHERE id_forum = '" + idForum + "'";
            cmd.ExecuteNonQuery();

            //els forums missatges
            cmd.CommandText = "UPDATE TBL_Forums_missatges SET data_baixa = '" + System.DateTime.Now.ToString() + "', id_usuari_baixa ='" + idUsuariBaixa + "'   WHERE id_forum = '" + idForum + "'";
            cmd.ExecuteNonQuery();



            //tanquem la connexió oberta
            if (cn.State == ConnectionState.Open)
            {
                cn.Close();
            }

        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}