﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace MvcSonin.Controllers
{ 
    public class ForumDiscussioController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /ForumDiscussio/

        public ViewResult Index()
        {
            try
            {
                //fem servir la crida a un stored proc
                return View(db.SP_IndexForumDiscussio_EXTEND().ToList());
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ForumDiscussio/Details/5

        public ViewResult Details(string id)
        {
            try
            {
                //tractem la cadena id que rebem

                string idForum_discussio = "";
                string idForum = "";
                string idTema = "";

                string[] a = id.Split('_');

                idForum_discussio = a[0];
                idForum = a[1];
                idTema = a[2];

                TBL_Forums_discussions tbl_forums_discussions = db.TBL_Forums_discussions.Single(t => t.id_forum_discussio == idForum_discussio && t.id_forum == idForum && t.id_tema == idTema);
                return View(tbl_forums_discussions);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ForumDiscussio/Create/5_3 (id_tema_idforum)

        public ActionResult Create(String id)
        {
            try
            {
                //tractem la cadena id que rebem
                string[] a = id.Split('_');

                //moscas a cañonazos
                Session["fd_idtema"] = a[0];
                Session["fd_idforum"] = a[1];

                return View();
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        } 

        //
        // POST: /ForumDiscussio/Create

        [HttpPost]
        public ActionResult Create(TBL_Forums_discussions tbl_forums_discussions)
        {
            try
            {
                //editem el usuari i la data de alta
                tbl_forums_discussions.id_usuari_alta = Session["usuari"].ToString(); ;
                tbl_forums_discussions.data_alta = System.DateTime.Now;

                tbl_forums_discussions.id_forum_discussio = "FDis" + System.DateTime.Now.ToString().Replace("/", "").Replace(":", "").Replace(" ", "");
                tbl_forums_discussions.id_tema = Session["fd_idtema"].ToString();
                tbl_forums_discussions.id_forum = Session["fd_idforum"].ToString();

                if (ModelState.IsValid)
                {
                    db.TBL_Forums_discussions.AddObject(tbl_forums_discussions);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }

                return View(tbl_forums_discussions);

            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }
        
        //
        // GET: /ForumDiscussio/Edit/5
 
        public ActionResult Edit(string id)
        {
            try
            {
                //tractem la cadena id que rebem

                string idForum_discussio = "";
                string idForum = "";
                string idTema = "";

                string[] a = id.Split('_');

                idForum_discussio = a[0];
                idForum = a[1];
                idTema = a[2];

                TBL_Forums_discussions tbl_forums_discussions = db.TBL_Forums_discussions.Single(t => t.id_forum_discussio == idForum_discussio && t.id_forum == idForum && t.id_tema == idTema);
                return View(tbl_forums_discussions);

            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // POST: /ForumDiscussio/Edit/5

        [HttpPost]
        public ActionResult Edit(TBL_Forums_discussions tbl_forums_discussions)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    db.TBL_Forums_discussions.Attach(tbl_forums_discussions);
                    db.ObjectStateManager.ChangeObjectState(tbl_forums_discussions, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                return View(tbl_forums_discussions);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ForumDiscussio/Delete/5
 
        public ActionResult Delete(string id)
        {
            try
            {
                string idForum_discussio = "";
                string idForum = "";
                string idTema = "";

                string[] a = id.Split('_');

                idForum_discussio = a[0];
                idForum = a[1];
                idTema = a[2];

                TBL_Forums_discussions tbl_forums_discussions = db.TBL_Forums_discussions.Single(t => t.id_forum_discussio == idForum_discussio && t.id_forum == idForum && t.id_tema == idTema);
                return View(tbl_forums_discussions);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }


        // No esborrem el registre. Editem el usuari i la data de baixa
        // POST: /ForumDiscussio/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {
            try
            {
                string idForum_discussio = "";
                string idForum = "";
                string idTema = "";

                string[] a = id.Split('_');

                idForum_discussio = a[0];
                idForum = a[1];
                idTema = a[2];

                TBL_Forums_discussions tbl_forums_discussions = db.TBL_Forums_discussions.Single(t => t.id_forum_discussio == idForum_discussio && t.id_forum == idForum && t.id_tema == idTema);

                //editem el usuari i la data de baixa
                tbl_forums_discussions.id_usuari_baixa = Session["usuari"].ToString(); ;
                tbl_forums_discussions.data_baixa = System.DateTime.Now;


                if (ModelState.IsValid)
                {
                    db.ObjectStateManager.ChangeObjectState(tbl_forums_discussions, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                return View(tbl_forums_discussions);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var forumesdiscusses = db.SP_IndexForumDiscussio_EXTEND().ToList();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from forumesdiscuss in forumesdiscusses

                              select new
                              {
                                  Tema = forumesdiscuss.desc_tema,
                                  Forum = forumesdiscuss.desc_forum,
                                  Nom_Discussio = forumesdiscuss.titol,
                                  Descripcio = forumesdiscuss.missatge,
                                  Id_usuari_alta = forumesdiscuss.id_usuari_alta,
                                  Data_alta = forumesdiscuss.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }


        // Cridem la vista de error
        // GET: /ForumDiscussio/Error

        public ViewResult Error()
        {
            return View();
        }

        // Tornem un llistat dels forums 
        // GET: /ForumDiscussio/SelectForum

        public ViewResult SelectForum()
        {
            try
            {
                //forums actius
                return View(db.SP_IndexForum_EXTEND().ToList());
            }
            catch (Exception e)
            {
                //passem el missatge de error a la vista
                ViewBag.error = e.Message;
                //adrecem la vista de errors
                return View("Error");
            }
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}