﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace MvcSonin.Controllers
{ 
    public class PreguntaController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /Pregunta/

        public ViewResult Index()
        {
            //fem servir un st.proc
            return View(db.SP_IndexPregunta_EXTEND().ToList());
        }

        //
        // GET: /Pregunta/Details/5

        public ViewResult Details(string id)
        {
            try
            {
                //tractem la cadena id que rebem
                string idTema = "";
                string idPregunta = "";


                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];


                TBL_Preguntes tbl_preguntes = db.TBL_Preguntes.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta);
                return View(tbl_preguntes);

            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // GET: /Pregunta/Create

        public ActionResult Create()
        {
            // Name property is what will be shown to the user. 
            ViewBag.id_tema = new SelectList(db.SP_IndexTema(), "id_tema", "desc_tema");

            return View();
        } 

        //
        // POST: /Pregunta/Create

        [HttpPost]
        public ActionResult Create(TBL_Preguntes tbl_preguntes)
        {
            try
            {
                //insertem els valors de manera automàtica
                tbl_preguntes.id_usuari_alta = Session["usuari"].ToString();
                tbl_preguntes.id_pregunta = "PR" + System.DateTime.Now.ToString().Replace("/", "").Replace(":", "").Replace(" ", "");

                if (ModelState.IsValid)
                {
                    db.TBL_Preguntes.AddObject(tbl_preguntes);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }

                //afegim per a que surti el valor escollit als desplegables
                ViewBag.id_tema = new SelectList(db.SP_IndexTema(), "id_tema", "desc_tema", tbl_preguntes.id_tema);


                return View(tbl_preguntes);

            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }
        
        //
        // GET: /Pregunta/Edit/5
 
        public ActionResult Edit(string id)
        {
            try
            {
                //tractem la cadena id que rebem
                string idTema = "";
                string idPregunta = "";


                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];


                TBL_Preguntes tbl_preguntes = db.TBL_Preguntes.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta);


                return View(tbl_preguntes);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // POST: /Pregunta/Edit/5

        [HttpPost]
        public ActionResult Edit(TBL_Preguntes tbl_preguntes)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    db.TBL_Preguntes.Attach(tbl_preguntes);
                    db.ObjectStateManager.ChangeObjectState(tbl_preguntes, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }

                return View(tbl_preguntes);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // GET: /Pregunta/Delete/5
 
        public ActionResult Delete(string id)
        {
            try
            {
                //tractem la cadena id que rebem
                string idTema = "";
                string idPregunta = "";


                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];


                TBL_Preguntes tbl_preguntes = db.TBL_Preguntes.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta);
                return View(tbl_preguntes);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        //
        // POST: /Pregunta/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {
            try
            {
                //tractem la cadena id que rebem
                string idTema = "";
                string idPregunta = "";


                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];


                TBL_Preguntes tbl_preguntes = db.TBL_Preguntes.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta);
                tbl_preguntes.id_usuari_baixa = "SONIN";//provisional
                db.TBL_Preguntes.DeleteObject(tbl_preguntes);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var questes = db.SP_IndexPregunta_EXTEND().ToList();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from quest in questes

                              select new
                              {
                                  Tema = quest.desc_tema,
                                  Pregunta = quest.desc_pregunta,
                                  Data_alta = quest.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}