﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a poder fer servir els combos relacionats
using MvcSonin.Helpers;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace MvcSonin.Controllers
{ 
    public class ValorRecomanatController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /ValorRecomanat/

        public ViewResult Index()
        {
            try
            {
                return View(db.SP_IndexValorRecomanat_EXTEND().ToList());
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ValorRecomanat/Details/5

        public ViewResult Details(string id)
        {
            try
            {
                //tractem la cadena id que rebem

                string idTema = "";
                string idPregunta = "";
                string idValorRecomanat = "";

                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];
                idValorRecomanat = a[2];


                TBL_Valors_recomanats tbl_valors_recomanats = db.TBL_Valors_recomanats.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_recomanat == idValorRecomanat);
                return View(tbl_valors_recomanats);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ValorRecomanat/Create

        public ActionResult Create()
        {
            try
            {
                //carreguem dos combos que siguin depenents. El valor de la combo fill anirà en funció
                //del valor de la combo del pare

                // Creem la combo pare
                var temaList = new SelectList(db.TBL_Temes.ToList(), "id_tema", "desc_tema");
                //el nom "id_tema" ha de ser el del camp del model!!
                ViewData["id_tema"] = temaList;

                // Creem la combo fill que carregarà en funció dels valors del pare
                var preguntaList = new CascadingSelectList(db.TBL_Preguntes.ToList(), "id_tema", "id_pregunta", "desc_pregunta");
                // ViewData["Preguntes"] = preguntaList;
                ViewData["id_pregunta"] = preguntaList;

   

                return View();
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        } 

        //
        // POST: /ValorRecomanat/Create

        [HttpPost]
        public ActionResult Create(TBL_Valors_recomanats tbl_valors_recomanats)
        {
            try
            {
                //insertem els valors de manera automàtica
                tbl_valors_recomanats.id_usuari_alta = Session["usuari"].ToString();
                tbl_valors_recomanats.id_valor_recomanat = "VRec" + System.DateTime.Now.ToString().Replace("/", "").Replace(":", "").Replace(" ", "");

                if (ModelState.IsValid)
                {
                    db.TBL_Valors_recomanats.AddObject(tbl_valors_recomanats);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }

                return View(tbl_valors_recomanats);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }
        
        //
        // GET: /ValorRecomanat/Edit/5
 
        public ActionResult Edit(string id)
        {
            try
            {

                //tractem la cadena id que rebem

                string idTema = "";
                string idPregunta = "";
                string idValorRecomanat = "";

                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];
                idValorRecomanat = a[2];


                TBL_Valors_recomanats tbl_valors_recomanats = db.TBL_Valors_recomanats.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_recomanat == idValorRecomanat);
                return View(tbl_valors_recomanats);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // POST: /ValorRecomanat/Edit/5

        [HttpPost]
        public ActionResult Edit(TBL_Valors_recomanats tbl_valors_recomanats)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    db.TBL_Valors_recomanats.Attach(tbl_valors_recomanats);
                    db.ObjectStateManager.ChangeObjectState(tbl_valors_recomanats, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                return View(tbl_valors_recomanats);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // GET: /ValorRecomanat/Delete/5
 
        public ActionResult Delete(string id)
        {
            try
            {
                //tractem la cadena id que rebem

                string idTema = "";
                string idPregunta = "";
                string idValorRecomanat = "";

                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];
                idValorRecomanat = a[2];


                TBL_Valors_recomanats tbl_valors_recomanats = db.TBL_Valors_recomanats.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_recomanat == idValorRecomanat);
                return View(tbl_valors_recomanats);
            }
            catch (Exception ex)
            {
                ViewBag.MissatgeError = ex.Message;
                return View("Error");
            }
        }

        //
        // POST: /ValorRecomanat/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {            
           
            //Al esborrar no esborrem sinò que afegim la data de baixa

            try
            {
                //tractem la cadena id que rebem

                string idTema = "";
                string idPregunta = "";
                string idValorRecomanat = "";

                string[] a = id.Split('_');

                idTema = a[0];
                idPregunta = a[1];
                idValorRecomanat = a[2];


                TBL_Valors_recomanats tbl_valors_recomanats = db.TBL_Valors_recomanats.Single(t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_recomanat == idValorRecomanat);

                if (ModelState.IsValid)
                {
                    tbl_valors_recomanats.data_baixa = System.DateTime.Now; //la data d'avui
                    tbl_valors_recomanats.id_usuari_baixa = Session["usuari"].ToString();

                    db.ObjectStateManager.ChangeObjectState(tbl_valors_recomanats, EntityState.Modified);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                return View(tbl_valors_recomanats);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }


        }

        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var valrecos = db.SP_IndexValorRecomanat_EXTEND().ToList();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from valrecs in valrecos

                              select new
                              {
                                  Tema = valrecs.desc_tema,
                                  Pregunta = valrecs.desc_pregunta,
                                  Possible_Resposta = valrecs.desc_valor_recomanat,
                                  Id_usuari_alta = valrecs.id_usuari_alta,
                                  Data_alta = valrecs.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }

        // Cridem la vista de error
        // GET: /ValorRecomanat/Error

        public ViewResult Error()
        {
            return View();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}