﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSonin.DAL;
//per a exportar a excel
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace MvcSonin.Controllers
{ 
    public class ValorRecomanatPossibleRespostaController : Controller
    {
        private SONINEntities db = new SONINEntities();

        //
        // GET: /ValorRecomanatPossibleResposta/

        public ViewResult Index()
        {
            try
            {
                //cridem a un st. procedure
                return View(db.SP_Valors_recomanats_possibles_respostes_EXTEND().ToList());
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

 
        //
        // GET: /ValorRecomanatPossibleResposta/Delete/5_3_56

        public ActionResult Delete(string id)
        {
            try
            {
                string[] a = id.Split('_');

                //treiem els valors dels paràmetres de la cadena get

                string idTema = a[0];
                string idPregunta = a[1];
                string idValorPossible = a[2];
                string idValorRecom = a[3];

                //cerquem el registre a la BBDD
                TBL_Valors_recomanats_possibles_respostes tbl_valors_recomanats_possibles_respostes = 
                    db.TBL_Valors_recomanats_possibles_respostes.Single
                    (t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_possible == idValorPossible &&  t.id_valor_recomanat == idValorRecom);
                
                return View(tbl_valors_recomanats_possibles_respostes);
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

        //
        // POST: /ValorRecomanatPossibleResposta/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(string id)
        {
            try
            {
                string[] a = id.Split('_');

                //actualitzarem les dades.

                string idTema = a[0];
                string idPregunta = a[1];
                string idValorPossible = a[2];
                string idValorRecom = a[3];

                TBL_Valors_recomanats_possibles_respostes tbl_valors_recomanats_possibles_respostes =
                    db.TBL_Valors_recomanats_possibles_respostes.Single
                    (t => t.id_tema == idTema && t.id_pregunta == idPregunta && t.id_valor_possible == idValorPossible && t.id_valor_recomanat == idValorRecom);
                
                //en aquest cas sí que esborrem el registre
                db.TBL_Valors_recomanats_possibles_respostes.DeleteObject(tbl_valors_recomanats_possibles_respostes);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

        // Tornem el llistat de les possibles preguntes
        // GET: /ValorRecomanatPossibleResposta/SelectPossibleResposta
        public ViewResult SelectPossibleResposta()
        {
            try
            {
                //return View(db.TBL_Valors_possibles_respostes.ToList().Where(t => t.data_baixa == null));
                return View(db.SP_IndexPossibleResposta_EXTEND().ToList());
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

        // Tornem el llistat de les respostes recomenades per a una pregunta concreta
        // GET: /ValorRecomanatPossibleResposta/SelectRespostaRecomanada/tema_pregunta_

        public ViewResult SelectRespostaRecomanada(String id)
        {
            try
            {
                //pasem els valors de la pregunta i el tema que hem escollit a 
                //la vista SelectPossibleResposta
                ViewBag.parametresAnteriors = id;
               

                return View(db.SP_IndexValorRecomanat_EXTEND().ToList());
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

        // Relacionem a la base de dades la possible pregunta amb la resposta recomenada
        // GET: /ValorRecomanatPossibleResposta/Relate/

        public ActionResult Relate(String id)
        {
            try
            {

                string[] a = id.Split('_');

                //actualitzarem les dades.

                string idTema = a[0];
                string idPregunta = a[1];
                string idValorPossible = a[2];
                string idValorRecom = a[3];

                //creem un objecte TBL_Valors_recomanats_possibles_respostes
                //i el desem a la BBDD
                TBL_Valors_recomanats_possibles_respostes vrpr = new TBL_Valors_recomanats_possibles_respostes();

                vrpr.data_alta = System.DateTime.Now;
                vrpr.id_usuari_alta = Session["usuari"].ToString();
                vrpr.id_pregunta = a[1];
                vrpr.id_tema = a[0];
                vrpr.id_valor_possible = a[2];
                vrpr.id_valor_recomanat = a[3];

                db.TBL_Valors_recomanats_possibles_respostes.AddObject(vrpr);
                db.SaveChanges();
                return RedirectToAction("Index");
                
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View("Error");
            }
        }

        /// <summary>
        /// Exportem a excel
        /// </summary>
        /// <returns></returns>
        public ActionResult toExcel()
        {
            try
            {

                exportToExcel();
                return View();
            }
            catch (Exception e)
            {
                ViewBag.error = e.Message;
                return View();
            }
        }

        /// <summary>
        /// métode per a exportar a Excel
        /// </summary>
        public void exportToExcel()
        {
            //This one is pretty easy, consisting of three parts:

            // * Creating the GridView placeholder
            // * Binding the query results to the GridView placeholder
            // * Dumping the results back to the browser

            // This example queries all contacts that have not unsubscribed, but you can imagine how easy it is to extend.
            var valrecosposes = db.SP_Valors_recomanats_possibles_respostes_EXTEND().ToList();
            var grid = new System.Web.UI.WebControls.GridView();

            grid.DataSource = from valrecospos in valrecosposes

                              select new
                              {
                                  Tema = valrecospos.desc_tema,
                                  Pregunta = valrecospos.desc_pregunta,
                                  Possible_Resposta = valrecospos.desc_valor_recomanat,
                                  Valor_possible = valrecospos.desc_valor_possible,
                                  Id_usuari_alta = valrecospos.id_usuari_alta,
                                  Data_alta = valrecospos.data_alta
                              };
            grid.DataBind();

            Response.ClearContent();
            Response.AddHeader("content-disposition", "attachment; filename=sonin.xls");
            Response.ContentType = "application/excel";
            StringWriter sw = new StringWriter();
            HtmlTextWriter htw = new HtmlTextWriter(sw);
            grid.RenderControl(htw);
            Response.Write(sw.ToString());
            Response.End();
        }
        
        // Cridem la vista de error
        // GET: /ValorRecomanatPossibleResposta/Error

        public ViewResult Error()
        {
            return View();
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}